#include "Engine_3D.h"

short x1,x2,y1,y2,z1,z2;
short tav,zoom;
unsigned char kix,kiy;

short sint[320];
short *cost;

short xtt[]={80,100,115,120,115,100,80,60,45,40,45,60,80};
short ytt[]={40,35,20,0, -20,-35,-40,-35,-20,0,20,35,40};
short ztt[]={0,0,0,0,0,0,0,0,0,0,0,0,0};

short g3xtt[256*PLOTS/GENER];
short g3ytt[256*PLOTS/GENER];
short g3ztt[256*PLOTS/GENER];

unsigned char g2xtt[256*PLOTS/GENER];
unsigned char g2ytt[256*PLOTS/GENER];


//==============================================================================
//==============================================================================
void InitSinCosTable(void)
{
  unsigned short a;
  
  for(a=0;a<256;a++) sint[a]=128*sin(1.40625*a*(PI/180));
  for(a=0;a<64;a++) sint[a+256]=128*sin(1.40625*a*(PI/180));
  cost = &sint[64];
}

//==============================================================================
void rotate(short x,short y,short z,short a,short b,short g)
{
  x1=((y*sint[a]+x*cost[a]) >> 7);
  y1=((y*cost[a]-x*sint[a]) >> 7);
  x2=((x1*cost[b]-z*sint[b]) >> 7);
  z1=((z*cost[b]+x1*sint[b]) >> 7);
  y2=((z1*sint[g]+y1*cost[g]) >> 7);
  z2=((z1*cost[g]-y1*sint[g]) >> 7);
}

//==============================================================================
void c3d22d(short x2, short y2, short z2)
{
  kix=x2*zoom/(z2+tav);
  kiy=y2*zoom/(y2+tav);
}

//==============================================================================
void generate3d(void)
{
//  short a,b,g;
//  unsigned short cn,c;
  
//  a=0;
//  b=0;
//  g=0;
//  cn=0;
 //   LCD_Line(40,40,70,100);
  
//  LCD_Line(40,40,100,40);
  
 // LCD_Line(70,100,100,40);
 
  //***********************
     
  g3xtt[0]=50;
  g3ytt[0]=50;
  g3ztt[0]=50;
  
 g3xtt[1]=50;
  g3ytt[1]=100;
  g3ztt[1]=50;
  
   g3xtt[2]=100;
  g3ytt[2]=50;
  g3ztt[2]=50;
  
  g3xtt[3]=100;
  g3ytt[3]=100;
  g3ztt[3]=50;

 g3xtt[4]=50;
  g3ytt[4]=50;
  g3ztt[4]=100;
  
  g3xtt[5]=50;
  g3ytt[5]=100;
  g3ztt[5]=100;
  
  g3xtt[6]=100;
  g3ytt[6]=50;
  g3ztt[6]=100;
  
  g3xtt[7]=100;
  g3ytt[7]=100;
  g3ztt[7]=100; 
  //**********************
/*  for(b=0;b<256;b=b+GENER)
  {
    for(c=0;c<PLOTS;c++)
    {
      rotate(xtt[c],ytt[c],ztt[c],a,b,g);
      g3xtt[cn]=x2;
      g3ytt[cn]=y2;
      g3ztt[cn]=z2;
      cn++;
    }
  }*/
}

//==============================================================================
void Start()
{
  unsigned char al,be,ga,xoff,yoff,xoi,yoi;
  unsigned short cn,cnt;

  zoom=300;  //400
  tav=1000; //2000-4000
  InitSinCosTable(); 
  al=0;
  be=0;
  ga=0;
  
  generate3d();
  xoff=100;
  yoff=84;
  xoi=1;
  yoi=1; 

  
   while(1)
   {
     for(cnt=0;cnt<255;cnt++)
     {
        for(cn=0;cn<(POLIGONS*PLOTS);cn++)
        {
          rotate(g3xtt[cn],g3ytt[cn],g3ztt[cn],al,be,ga);
          c3d22d(x2,y2,z2);
          g2xtt[cn]= kix+xoff;
          g2ytt[cn]= kiy+yoff;
        }

        cnt=0;
        while(1)
        {
          for(cn=0;cn<1;cn++)
          {
              LCD_Line(g2xtt[cnt+cn],g2ytt[cnt+cn],g2xtt[cnt+cn+1],g2ytt[cnt+cn+1]);
          }
          cnt++;
          if(cnt==(8)) break;
        }
        
        al++;

       // al++;
        if((al & 3)!=0) be++;
        if((al & 15)!=0) ga++;
      /*  if(xoi==1)
        {
          xoff++;
          if(xoff>50) xoi=0;
        }
        else
        {
          xoff--;
          if(xoff<29) xoi=1;
        }*/
        if(yoi==1)
        {
          yoff++;
          if(yoff>34) yoi=0;
        }
        else
        {
        //  yoff--;
        //  if(yoff<32) yoi=1;
        }
     //   FlushScreen();
      LCD_FillScr(RGB_WHITE);  
     //   GLCD_Clear(1);
     }
  }  
  
}

//==============================================================================
