//-------------------------------------------------------------------------------
//   PIT
//-------------------------------------------------------------------------------

#include "Board.h"
#include "SPI.h"
//#include "main.c"

#define PIT_INTERRUPT_LEVEL	1
//#define PIV_PERIOD 		5000     	//   PIT - // 48 000 000/(16*PIV_PERIOD)
#define Frec                    1                          
#define PIV_PERIOD 		48000000/(16*Frec)


//static unsigned char U_NEG_old_state=0; //       LCD
unsigned char stat;

//   PIT
void Periodic_Interval_Timer_handler(void)
{
    unsigned int status;
    //   PIT
    status = AT91C_BASE_PITC->PITC_PIVR;
    status =status; //      
    //*   
   //   LCD_FillScr(RGB_RED);
    if (stat==10) {
   AT91F_PIO_SetOutput( AT91C_BASE_PIOA, LED2) ;
   stat=17;
    }
    else{AT91F_PIO_ClearOutput( AT91C_BASE_PIOA, LED2); stat=10;}
    
    

}
//  PIT
void PIT_init(void)
{
        // AIC
	AT91F_AIC_ConfigureIt ( AT91C_BASE_AIC, AT91C_ID_SYS, PIT_INTERRUPT_LEVEL,
                               AT91C_AIC_SRCTYPE_INT_POSITIVE_EDGE,
                               Periodic_Interval_Timer_handler);
	// PIT,    PIT    
	AT91C_BASE_PITC->PITC_PIMR = AT91C_PITC_PITEN | AT91C_PITC_PITIEN | PIV_PERIOD;
        AT91F_AIC_EnableIt (AT91C_BASE_AIC, AT91C_ID_SYS);
}
