 #include <LPC2103.H>
volatile  unsigned char t;

__irq void TM0_Handler (void){
	if (t&0x01) 	IOSET = 0x0F; else  IOCLR = 0x0F;
	t++;
	//IODIR0 = 0x000000FF;
	if (IOSET > 0xFF) {IOSET = 0; IOCLR = 0xFF;}
	T0IR |=1;
	VICVectAddr=0;
}			 

void InitTimer0 (void)
{
	VICVectCntl0=0x24; //
	VICVectAddr0 = (unsigned int)TM0_Handler;
	T0MR0=112500; //1125; //1125  1000 , 5625  200 
	T0MCR=0x03; //     T0MR0
	T0PR=15; //prescaler = 16
	T0TCR=0x02; //
	T0TCR=0x01; //
	VICIntSelect=0x00; //  IRQ
	VICIntEnable=(1<<4); // TM0
return;
}
