

#define highCS 		(IOSET = (1 << 15))
#define lowCS		(IOCLR = (1 << 15))
#define highRS		(IOSET = (1 << 16))
#define lowRS		(IOCLR = (1 << 16))
#define highRES		(IOSET = (1 << 17))
#define lowRES      (IOCLR = (1 << 17))

/*--------------COLOR--------------*/
#define   RGB(r,g,b)    ((r & 0x1F) << 11) + ((g & 0x3F) << 5) + (b & 0x1F)
#define   RGB_GREEN     RGB(0,63,0)
#define   RGB_BLUE      RGB(0,0,31)
#define   RGB_RED       RGB(31,0,0)
#define   RGB_GREEY     RGB(20,20,20)
#define   RGB_YELLOW    0xDEE0
#define   RGB_ORANGE    0xAB00
#define   RGB_PINK      0xF97F
#define   RGB_BROWN     0x8200
#define   RGB_GREY      0x8410
#define   RGB_VIOLET    0x91D4
#define   RGB_WHITE     0xFFFF
#define   RGB_BLACK     0x0000
/*---------------------------------*/


void LCD_Write8(unsigned char lcd_data);
void LCD_Write16(unsigned int lcd_data);
void LCD_SetCommand(void); //   
void LCD_SetData(void);  //   
volatile void Init_LCD(void); // 
void LCD_FillRect(unsigned char X1,unsigned char Y1,unsigned char X2,unsigned char Y2); //  
void LCD_FillScr(unsigned int color);  //   
void LCD_PutPixel(unsigned char X1,unsigned char Y1,unsigned int color);  //   
void LCD_BlackScreen(void);  // 
void LCD_WhiteScreen(void);  // 
void LCD_DataScreen(void);  // 
void LCD_Circle(unsigned char cx, unsigned char cy ,unsigned char radius,unsigned color); // 
void LCD_Line(int x1, int y1, int x2, int y2); //  
void SPI_Init(void);
